﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;

namespace UltraGridDragRows
{
    public partial class Form1 : Form
    {
        private BindingList<MyTargetObject> MyObjectList;

        public Form1()
        {
            InitializeComponent();
            MyObjectList = new BindingList<MyTargetObject>();

            for (int i = 0; i < 10; i++)
            {
                MyTargetObject mto = new MyTargetObject("Main Value " + i.ToString());
                mto.MyTagetList = new BindingList<MyObject>();

                for (int j = 0; j < 10; j++)
                {
                    MyObject mo = new MyObject("Item " + j.ToString(), "Value " + j.ToString(), "Test " + i.ToString());
                    mto.MyTagetList.Add(mo);
                }
                MyObjectList.Add(mto);
            }

            ultraGrid1.DataSource = MyObjectList;
            ultraGrid1.Rows.ExpandAll(true);
        }

        private void ultraGrid1_SelectionDrag(object sender, CancelEventArgs e)
        {
            if (ultraGrid1.ActiveRow.ListObject.GetType() != typeof(MyObject)) return;
            ultraGrid1.DoDragDrop((MyObject)ultraGrid1.ActiveRow.ListObject, DragDropEffects.Move);
        }

        private void ultraGrid1_DragDrop(object sender, DragEventArgs e)
        {
            UIElement a = ultraGrid1.DisplayLayout.UIElement.ElementFromPoint(ultraGrid1.PointToClient(new Point(e.X, e.Y)));
            UltraGridRow Row = a.GetContext(typeof(UltraGridRow)) as UltraGridRow;

            if (Row.ParentRow == null) return;

            MyTargetObject ParentObject = (MyTargetObject)ultraGrid1.ActiveRow.ParentRow.ListObject;
            MyObject RowObject = (MyObject)ultraGrid1.ActiveRow.ListObject;
            ((MyTargetObject)ParentObject).MyTagetList.Remove(RowObject);

            MyTargetObject NewParentObject = (MyTargetObject)Row.ParentRow.ListObject;
            ((MyTargetObject)NewParentObject).MyTagetList.Add(RowObject);
            ultraGrid1.Rows.ExpandAll(true);
        }


        private void ultraGrid1_DragEnter(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.Move;
        }

        private void ultraGrid2_DragEnter(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.Move;
        }
    }

    public class MyObject
    {

        #region Properties
        private string item_1;

        public string Item_1
        {
            get { return item_1; }
            set { item_1 = value; }
        }
        private string item_2;

        public string Item_2
        {
            get { return item_2; }
            set { item_2 = value; }
        }
        private string item_3;

        public string Item_3
        {
            get { return item_3; }
            set { item_3 = value; }
        }
        #endregion

        public MyObject(string It_1, string It_2, string It_3)
        {
            this.item_1 = It_1;
            this.item_2 = It_2;
            this.item_3 = It_3;
        }
    }

    public class MyTargetObject
    {
        private string mainItem;

        public string MainItem
        {
            get { return mainItem; }
            set { mainItem = value; }
        }

        private BindingList<MyObject> myTagetList;

        public BindingList<MyObject> MyTagetList
        {
            get { return myTagetList; }
            set { myTagetList = value; }
        }


        public MyTargetObject(string MainIatem)
        {
            this.mainItem = MainIatem;
            this.myTagetList = new BindingList<MyObject>();
        }
    }

}
